SystemOrganization addCategory: #'Pier-Setup'!

Object subclass: #PRDistribution
	instanceVariableNames: 'blog contentsWidget environmentPage metaEnvironmentPage breadcrumbWidget commandsPage googleAnalyticsWidget navigationWidget siteTitlePage sitemapPage stylesheetFile systemManagementPage usefulCommandsWidget viewsPage menuWidget kernel root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Setup'!

!PRDistribution methodsFor: 'pages' stamp: 'tg 9/5/2008 23:24'!
blog
	^ PBBlog named: 'blog'! !

!PRDistribution methodsFor: 'pages' stamp: 'tg 9/5/2008 23:08'!
breadcrumbWidget
	^ (PRComponent named: 'breadcrumb')
		componentClass: PRBreadcrumbWidget;
		yourself! !

!PRDistribution methodsFor: 'pages' stamp: 'tg 9/5/2008 23:23'!
commandsPage
	^ (PRPage named: 'commands') 
			addChild: ((PRComponent named: 'widget') componentClass: PRCommandsWidget; yourself);
			contents:
'Commands
+widget+'! !

!PRDistribution methodsFor: 'pages' stamp: 'tg 9/5/2008 23:24'!
contentsWidget
	^ (PRComponent named: 'contents')
		componentClass: PRContentsWidget;
		write: '%c'
			using: PRContentsWidget descriptionHeading;
		yourself! !

!PRDistribution methodsFor: 'creation' stamp: 'tg 9/5/2008 23:51'!
create
	"self new create"
	PRKernel reset.
	root
		addChild: blog;
		addChild: (environmentPage
				addChild: siteTitlePage;
				addChild: menuWidget;
				addChild: navigationWidget;
				addChild: breadcrumbWidget;
				addChild: googleAnalyticsWidget;
				addChild: sitemapPage;
				addChild: viewsPage;
				addChild: commandsPage;
				addChild: usefulCommandsWidget;
				addChild: contentsWidget;
				addChild: stylesheetFile;
				addChild: systemManagementPage;
				yourself);
		addChild: metaEnvironmentPage.
		
	root localEnvironment: environmentPage.
	environmentPage localEnvironment: metaEnvironmentPage.
	metaEnvironmentPage localEnvironment: metaEnvironmentPage.

	root localStyleSheet: stylesheetFile.

	root enumerator with; all; do: [:each  |
		each securityDecoration owner: self kernel users anyOne.
		each securityDecoration group: self kernel groups anyOne.].

	self makePrivate: environmentPage.
	self makePrivate: metaEnvironmentPage.
	self makePrivate: sitemapPage.
	self makePrivate: viewsPage.
	self makePrivate: commandsPage.
	self makePrivate: systemManagementPage.
	
	PRPierFrame 
		registerAsApplication: 'pier'
		kernel: self kernel! !

!PRDistribution methodsFor: 'pages' stamp: 'tg 9/5/2008 23:00'!
environmentPage
	^ (PRPage named: 'environment')
		title: '_Environment';
		contents: '<div class="container">
	<div class="header column span-24">
		<div class="title column span-24">+title+</div>
		<div class="menu column span-24 last">+menu+</div>
	</div>
	<div class="body column span-24">
		<div class="navigation column span-6">+navigation+</div>
		<div class="contents column span-18 last">+contents+</div>
	</div>
	<div class="footer column span-24">
		<div class="sitemap column span-6">+sitemap+</div>
		<div class="commands column span-6">+commands+</div>
		<div class="views column span-6">+views+</div>
		<div class="column span-6 last">
			Powered by *Pier>http://www.lukas-renggli.ch/smalltalk/pier*.
			+usefulcommands+
		</div>
	</div>
</div>
+googleanalytics+
';
		yourself! !

!PRDistribution methodsFor: 'pages' stamp: 'tg 9/5/2008 22:44'!
googleAnalyticsWidget
	^ (PRComponent named: 'googleanalytics')
		title: 'Google Analytics';
		componentClass: PRGoogleAnalyticsWidget! !

!PRDistribution methodsFor: 'initialize' stamp: 'tg 9/5/2008 23:26'!
initialize

	root := self kernel root.

	environmentPage := self environmentPage.
	metaEnvironmentPage := self metaEnvironmentPage.
	contentsWidget := self contentsWidget.
	blog := self blog.
	breadcrumbWidget := self breadcrumbWidget.
	commandsPage := self commandsPage.
	googleAnalyticsWidget := self googleAnalyticsWidget.
	menuWidget := self menuWidget.
	navigationWidget := self navigationWidget.
	siteTitlePage := self siteTitlePage.
	sitemapPage := self sitemapPage.
	stylesheetFile := self stylesheetFile.
	systemManagementPage := self systemManagementPages.
	usefulCommandsWidget := self usefulCommandsWidget.
	viewsPage := self viewsPage.! !

!PRDistribution methodsFor: 'initialize' stamp: 'tg 9/5/2008 23:24'!
kernel

	^kernel isNil ifTrue: [kernel := PRKernel named: 'Pier'] ifFalse: [kernel]. ! !

!PRDistribution methodsFor: 'rights' stamp: 'tg 9/5/2008 22:52'!
makePrivate: aStructure

	aStructure securityDecoration owner: self kernel users anyOne.
	aStructure securityDecoration otherPermissions: Set new.
	aStructure securityDecoration group: self kernel groups anyOne.
! !

!PRDistribution methodsFor: 'rights' stamp: 'tg 9/5/2008 22:59'!
makePublic: aStructure

	aStructure securityDecoration owner: self kernel users anyOne.
	aStructure securityDecoration otherPermissions: Set new.
	aStructure securityDecoration group: self kernel groups anyOne.
! !

!PRDistribution methodsFor: 'pages' stamp: 'tg 9/5/2008 22:44'!
menuWidget
	^ (PRComponent named: 'menu')
		componentClass: PRChildrenWidget;
		write: 1
			using: PRChildrenWidget descriptionLevel;
		write: true
			using: PRChildrenWidget descriptionHighlightPath;
		yourself! !

!PRDistribution methodsFor: 'pages' stamp: 'tg 9/5/2008 22:41'!
metaEnvironmentPage
	^ (PRPage named: 'metaenvironment')
		title: '_Meta Environment';
		contents: '<div class="container metaenvironment">
	<div class="span-24 last metaheader">
		Meta page: +/environment/breadcrumb+
	</div>
	<div class="span-24 last">
		+/environment/contents+
	</div>
	<div class="span-24 last metafooter">
		<div class="span-10">+/environment/commands+</div>
		<div class="span-10 last">+/environment/sitemap+</div>
	</div>

</div>';
		yourself! !

!PRDistribution methodsFor: 'pages' stamp: 'tg 9/5/2008 22:44'!
navigationWidget
	^ (PRComponent named: 'navigation')
		componentClass: PRChildrenWidget;
		write: 2
			using: PRChildrenWidget descriptionLevel;
		write: true
			using: PRChildrenWidget descriptionExpand;
		yourself! !

!PRDistribution methodsFor: 'pages' stamp: 'tg 9/5/2008 22:45'!
siteTitlePage
	^ (PRPage named: 'title')
		contents: '!!*/*';
		yourself! !

!PRDistribution methodsFor: 'pages' stamp: 'tg 9/5/2008 23:24'!
sitemapPage
	^ (PRPage named: 'sitemap')
		addChild: ((PRComponent named: 'widget')
				componentClass: PRTreeWidget;
				yourself);
		contents: 'Sitemap
			+widget+'! !

!PRDistribution methodsFor: 'pages' stamp: 'tg 9/5/2008 22:47'!
stylesheetFile

	^(PRFile named: 'css')
		mimetype: 'text/css';
		contents: 
'
body {margin-top: 0px;}

h1, h2, h3, h4, h5, h6 { margin: 0; font-weight: inherit; font-size: 100%; line-height: auto; }
h1 { font-size: 2em; margin-bottom: 0.75em; }
h2 { font-size: 1.5em; line-height: 1; margin-bottom: 1em; }
h3 { font-size: 1.2em; height: 1.25em; line-height: 1.25; margin-bottom: 1.25em; }
h4 { font-size: 1em; font-weight: bold; margin-bottom: 1.5em; }
h5 { font-size: 1em; font-weight: bold; }
h6 { font-size: 1em; }


/* PIER */
.broken { color: #8a1f11; }
.protected { color: #514721; }
a.view, a.command {color: gray;}
a {text-decoration: none;}
a.environment:after {content: "*";}

/* HEADER */
.header .title a.page {
	outline: none;
	display: block;
}
.header .search input {
	width: 220px;
	outline: none;
}
.header .search ul {
	margin: 0;
	padding: 0;
	background: #fff;
	list-style-type: none;
	border: 1px solid #666;
	border-top: none;}
.header .search li.selected {
	background-color: #009;}
.header .search li {
	margin: 0;
	display: block;
	padding: 0.2em;
	cursor: pointer;
	list-style-type: none;}
.header .search a {
	text-decoration: none;}
.header .search li.selected a {
	color: #fff;}
.header .menu {
	height: 4em;}
.header .menu ul {
	margin: 0 0 1em 0;
	list-style-type: none;}
.header .menu ul li {
	float: left;
	margin-right: 10px;
	list-style-type: none;}
.header .menu .active {
	font-weight: bold;}

/* NAVIGATION */
.navigation ul {
	margin-top: 0;
	margin-left: 0;
	list-style-type: none;}
.navigation ul ul {
	margin-bottom: 0;
	margin-left: 1.5em;}
.navigation .active {
	font-weight: bold;}

/* FOOTER */
.footer {
	font-size: 0.8em;
	margin-top: 10em;
	text-align: left;
	border-top: 1px solid #ddd;}
.footer ul {
	list-style: none;
	margin-left: 0em;}
.footer ul ul {
	margin-left: 1.5em;}

/* META */
.metaheader {background: #C3D9FF; font-size: 200%}
.metaheader ul {display: inline; margin: 0;}
.metaheader li {list-style: none; display: inline; margin: 0;}
.metaheader li:after {content: "/"}
.metaenvironment.container {border: 1px solid #C3D9FF; margin-top: 0;}
.metafooter {background: #C3D9FF;}
.metafooter li {list-style: none;}
'! !

!PRDistribution methodsFor: 'pages' stamp: 'tg 9/5/2008 22:31'!
systemManagementPages
	
	^(PRPage named: 'systemmanagement')
		title: '_System Management';
"		addChild: ((PRComponent named: 'seasideversions') componentClass: WAVersionUploader; yourself);
"
		addChild: ((PRComponent named: 'users') componentClass: PUUsersWidget; yourself);
		addChild: ((PRComponent named: 'groups') componentClass: PUGroupsWidget; yourself);
		addChild: ((PRComponent named: 'persistency') componentClass: PRPersistencySettings; yourself);
		addChild: ((PRComponent named: 'kernel') componentClass: PRKernelSettings; yourself);
		contents:
'!!Users
+users+

!!User Group
+groups+

!!Persistency
+persistency+

!!Pier Kernel Settings
+kernel+

';
		yourself! !

!PRDistribution methodsFor: 'pages' stamp: 'tg 8/27/2008 13:46'!
usefulCommandsWidget
	^ (PRComponent named: 'usefulcommands')
			title: 'Useful commands';
			componentClass: PRCommandsWidget;
			yourself! !

!PRDistribution methodsFor: 'pages' stamp: 'tg 9/5/2008 23:24'!
viewsPage
	^ (PRPage named: 'views')
		addChild: ((PRComponent named: 'widget')
				componentClass: PRViewsWidget;
				yourself);
		contents: 'Views
			+widget+'! !
